# -*- coding: utf-8 -*-
from setuphelpers import *


def install():
    # Initializing variables
    package_version = control.get_software_version()
    # removing previous version
    for uninstall in installed_softwares("OpenSC smartcard framework"):
        print("Uninstall %s" % uninstall["name"])
        cmd = uninstall_cmd(uninstall["key"])
        run(cmd)

    # Installing the package
    install_msi_if_needed(
        "OpenSC-%s_win32.msi" % package_version,
        min_version=package_version,
    )

    if iswin64():
        install_msi_if_needed(
            "OpenSC-%s_win64.msi" % package_version,
            min_version=package_version,
        )

    if not 'opensc' in registry_readstring(HKEY_LOCAL_MACHINE,r"SYSTEM\CurrentControlSet\Control\Session Manager\Environment","Path").lower():
        add_to_system_path(makepath(programfiles,'OpenSC Project','OpenSC','tools'))

